]> git.notmuchmail.org Git - notmuch/blob - test/test-lib.sh
Copy test framework from Git
[notmuch] / test / test-lib.sh
1 #!/bin/sh
2 #
3 # Copyright (c) 2005 Junio C Hamano
4 #
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
9 #
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
13 # GNU General Public License for more details.
14 #
15 # You should have received a copy of the GNU General Public License
16 # along with this program.  If not, see http://www.gnu.org/licenses/ .
17
18 # if --tee was passed, write the output not only to the terminal, but
19 # additionally to the file test-results/$BASENAME.out, too.
20 case "$GIT_TEST_TEE_STARTED, $* " in
21 done,*)
22         # do not redirect again
23         ;;
24 *' --tee '*|*' --va'*)
25         mkdir -p test-results
26         BASE=test-results/$(basename "$0" .sh)
27         (GIT_TEST_TEE_STARTED=done ${SHELL-sh} "$0" "$@" 2>&1;
28          echo $? > $BASE.exit) | tee $BASE.out
29         test "$(cat $BASE.exit)" = 0
30         exit
31         ;;
32 esac
33
34 # Keep the original TERM for say_color
35 ORIGINAL_TERM=$TERM
36
37 # For repeatability, reset the environment to known value.
38 LANG=C
39 LC_ALL=C
40 PAGER=cat
41 TZ=UTC
42 TERM=dumb
43 export LANG LC_ALL PAGER TERM TZ
44 EDITOR=:
45 unset VISUAL
46 unset GIT_EDITOR
47 unset AUTHOR_DATE
48 unset AUTHOR_EMAIL
49 unset AUTHOR_NAME
50 unset COMMIT_AUTHOR_EMAIL
51 unset COMMIT_AUTHOR_NAME
52 unset EMAIL
53 unset GIT_ALTERNATE_OBJECT_DIRECTORIES
54 unset GIT_AUTHOR_DATE
55 GIT_AUTHOR_EMAIL=author@example.com
56 GIT_AUTHOR_NAME='A U Thor'
57 unset GIT_COMMITTER_DATE
58 GIT_COMMITTER_EMAIL=committer@example.com
59 GIT_COMMITTER_NAME='C O Mitter'
60 unset GIT_DIFF_OPTS
61 unset GIT_DIR
62 unset GIT_WORK_TREE
63 unset GIT_EXTERNAL_DIFF
64 unset GIT_INDEX_FILE
65 unset GIT_OBJECT_DIRECTORY
66 unset GIT_CEILING_DIRECTORIES
67 unset SHA1_FILE_DIRECTORIES
68 unset SHA1_FILE_DIRECTORY
69 unset GIT_NOTES_REF
70 unset GIT_NOTES_DISPLAY_REF
71 unset GIT_NOTES_REWRITE_REF
72 unset GIT_NOTES_REWRITE_MODE
73 GIT_MERGE_VERBOSITY=5
74 export GIT_MERGE_VERBOSITY
75 export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
76 export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
77 export EDITOR
78 GIT_TEST_CMP=${GIT_TEST_CMP:-diff -u}
79
80 # Protect ourselves from common misconfiguration to export
81 # CDPATH into the environment
82 unset CDPATH
83
84 unset GREP_OPTIONS
85
86 case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
87         1|2|true)
88                 echo "* warning: Some tests will not work if GIT_TRACE" \
89                         "is set as to trace on STDERR ! *"
90                 echo "* warning: Please set GIT_TRACE to something" \
91                         "other than 1, 2 or true ! *"
92                 ;;
93 esac
94
95 # Convenience
96 #
97 # A regexp to match 5 and 40 hexdigits
98 _x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
99 _x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
100
101 # Each test should start with something like this, after copyright notices:
102 #
103 # test_description='Description of this test...
104 # This test checks if command xyzzy does the right thing...
105 # '
106 # . ./test-lib.sh
107 [ "x$ORIGINAL_TERM" != "xdumb" ] && (
108                 TERM=$ORIGINAL_TERM &&
109                 export TERM &&
110                 [ -t 1 ] &&
111                 tput bold >/dev/null 2>&1 &&
112                 tput setaf 1 >/dev/null 2>&1 &&
113                 tput sgr0 >/dev/null 2>&1
114         ) &&
115         color=t
116
117 while test "$#" -ne 0
118 do
119         case "$1" in
120         -d|--d|--de|--deb|--debu|--debug)
121                 debug=t; shift ;;
122         -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
123                 immediate=t; shift ;;
124         -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
125                 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
126         -h|--h|--he|--hel|--help)
127                 help=t; shift ;;
128         -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
129                 verbose=t; shift ;;
130         -q|--q|--qu|--qui|--quie|--quiet)
131                 quiet=t; shift ;;
132         --with-dashes)
133                 with_dashes=t; shift ;;
134         --no-color)
135                 color=; shift ;;
136         --no-python)
137                 # noop now...
138                 shift ;;
139         --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
140                 valgrind=t; verbose=t; shift ;;
141         --tee)
142                 shift ;; # was handled already
143         --root=*)
144                 root=$(expr "z$1" : 'z[^=]*=\(.*\)')
145                 shift ;;
146         *)
147                 echo "error: unknown test option '$1'" >&2; exit 1 ;;
148         esac
149 done
150
151 if test -n "$color"; then
152         say_color () {
153                 (
154                 TERM=$ORIGINAL_TERM
155                 export TERM
156                 case "$1" in
157                         error) tput bold; tput setaf 1;; # bold red
158                         skip)  tput bold; tput setaf 2;; # bold green
159                         pass)  tput setaf 2;;            # green
160                         info)  tput setaf 3;;            # brown
161                         *) test -n "$quiet" && return;;
162                 esac
163                 shift
164                 printf "* %s" "$*"
165                 tput sgr0
166                 echo
167                 )
168         }
169 else
170         say_color() {
171                 test -z "$1" && test -n "$quiet" && return
172                 shift
173                 echo "* $*"
174         }
175 fi
176
177 error () {
178         say_color error "error: $*"
179         GIT_EXIT_OK=t
180         exit 1
181 }
182
183 say () {
184         say_color info "$*"
185 }
186
187 test "${test_description}" != "" ||
188 error "Test script did not set test_description."
189
190 if test "$help" = "t"
191 then
192         echo "$test_description"
193         exit 0
194 fi
195
196 exec 5>&1
197 if test "$verbose" = "t"
198 then
199         exec 4>&2 3>&1
200 else
201         exec 4>/dev/null 3>/dev/null
202 fi
203
204 test_failure=0
205 test_count=0
206 test_fixed=0
207 test_broken=0
208 test_success=0
209
210 die () {
211         code=$?
212         if test -n "$GIT_EXIT_OK"
213         then
214                 exit $code
215         else
216                 echo >&5 "FATAL: Unexpected exit with code $code"
217                 exit 1
218         fi
219 }
220
221 GIT_EXIT_OK=
222 trap 'die' EXIT
223
224 # The semantics of the editor variables are that of invoking
225 # sh -c "$EDITOR \"$@\"" files ...
226 #
227 # If our trash directory contains shell metacharacters, they will be
228 # interpreted if we just set $EDITOR directly, so do a little dance with
229 # environment variables to work around this.
230 #
231 # In particular, quoting isn't enough, as the path may contain the same quote
232 # that we're using.
233 test_set_editor () {
234         FAKE_EDITOR="$1"
235         export FAKE_EDITOR
236         EDITOR='"$FAKE_EDITOR"'
237         export EDITOR
238 }
239
240 test_decode_color () {
241         sed     -e 's/.\[1m/<WHITE>/g' \
242                 -e 's/.\[31m/<RED>/g' \
243                 -e 's/.\[32m/<GREEN>/g' \
244                 -e 's/.\[33m/<YELLOW>/g' \
245                 -e 's/.\[34m/<BLUE>/g' \
246                 -e 's/.\[35m/<MAGENTA>/g' \
247                 -e 's/.\[36m/<CYAN>/g' \
248                 -e 's/.\[m/<RESET>/g'
249 }
250
251 q_to_nul () {
252         perl -pe 'y/Q/\000/'
253 }
254
255 q_to_cr () {
256         tr Q '\015'
257 }
258
259 append_cr () {
260         sed -e 's/$/Q/' | tr Q '\015'
261 }
262
263 remove_cr () {
264         tr '\015' Q | sed -e 's/Q$//'
265 }
266
267 test_tick () {
268         if test -z "${test_tick+set}"
269         then
270                 test_tick=1112911993
271         else
272                 test_tick=$(($test_tick + 60))
273         fi
274         GIT_COMMITTER_DATE="$test_tick -0700"
275         GIT_AUTHOR_DATE="$test_tick -0700"
276         export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
277 }
278
279 # Call test_commit with the arguments "<message> [<file> [<contents>]]"
280 #
281 # This will commit a file with the given contents and the given commit
282 # message.  It will also add a tag with <message> as name.
283 #
284 # Both <file> and <contents> default to <message>.
285
286 test_commit () {
287         file=${2:-"$1.t"}
288         echo "${3-$1}" > "$file" &&
289         git add "$file" &&
290         test_tick &&
291         git commit -m "$1" &&
292         git tag "$1"
293 }
294
295 # Call test_merge with the arguments "<message> <commit>", where <commit>
296 # can be a tag pointing to the commit-to-merge.
297
298 test_merge () {
299         test_tick &&
300         git merge -m "$1" "$2" &&
301         git tag "$1"
302 }
303
304 # This function helps systems where core.filemode=false is set.
305 # Use it instead of plain 'chmod +x' to set or unset the executable bit
306 # of a file in the working directory and add it to the index.
307
308 test_chmod () {
309         chmod "$@" &&
310         git update-index --add "--chmod=$@"
311 }
312
313 # Use test_set_prereq to tell that a particular prerequisite is available.
314 # The prerequisite can later be checked for in two ways:
315 #
316 # - Explicitly using test_have_prereq.
317 #
318 # - Implicitly by specifying the prerequisite tag in the calls to
319 #   test_expect_{success,failure,code}.
320 #
321 # The single parameter is the prerequisite tag (a simple word, in all
322 # capital letters by convention).
323
324 test_set_prereq () {
325         satisfied="$satisfied$1 "
326 }
327 satisfied=" "
328
329 test_have_prereq () {
330         case $satisfied in
331         *" $1 "*)
332                 : yes, have it ;;
333         *)
334                 ! : nope ;;
335         esac
336 }
337
338 # You are not expected to call test_ok_ and test_failure_ directly, use
339 # the text_expect_* functions instead.
340
341 test_ok_ () {
342         test_success=$(($test_success + 1))
343         say_color "" "  ok $test_count: $@"
344 }
345
346 test_failure_ () {
347         test_failure=$(($test_failure + 1))
348         say_color error "FAIL $test_count: $1"
349         shift
350         echo "$@" | sed -e 's/^/        /'
351         test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
352 }
353
354 test_known_broken_ok_ () {
355         test_fixed=$(($test_fixed+1))
356         say_color "" "  FIXED $test_count: $@"
357 }
358
359 test_known_broken_failure_ () {
360         test_broken=$(($test_broken+1))
361         say_color skip "  still broken $test_count: $@"
362 }
363
364 test_debug () {
365         test "$debug" = "" || eval "$1"
366 }
367
368 test_run_ () {
369         test_cleanup=:
370         eval >&3 2>&4 "$1"
371         eval_ret=$?
372         eval >&3 2>&4 "$test_cleanup"
373         return 0
374 }
375
376 test_skip () {
377         test_count=$(($test_count+1))
378         to_skip=
379         for skp in $GIT_SKIP_TESTS
380         do
381                 case $this_test.$test_count in
382                 $skp)
383                         to_skip=t
384                 esac
385         done
386         if test -z "$to_skip" && test -n "$prereq" &&
387            ! test_have_prereq "$prereq"
388         then
389                 to_skip=t
390         fi
391         case "$to_skip" in
392         t)
393                 say_color skip >&3 "skipping test: $@"
394                 say_color skip "skip $test_count: $1"
395                 : true
396                 ;;
397         *)
398                 false
399                 ;;
400         esac
401 }
402
403 test_expect_failure () {
404         test "$#" = 3 && { prereq=$1; shift; } || prereq=
405         test "$#" = 2 ||
406         error "bug in the test script: not 2 or 3 parameters to test-expect-failure"
407         if ! test_skip "$@"
408         then
409                 say >&3 "checking known breakage: $2"
410                 test_run_ "$2"
411                 if [ "$?" = 0 -a "$eval_ret" = 0 ]
412                 then
413                         test_known_broken_ok_ "$1"
414                 else
415                         test_known_broken_failure_ "$1"
416                 fi
417         fi
418         echo >&3 ""
419 }
420
421 test_expect_success () {
422         test "$#" = 3 && { prereq=$1; shift; } || prereq=
423         test "$#" = 2 ||
424         error "bug in the test script: not 2 or 3 parameters to test-expect-success"
425         if ! test_skip "$@"
426         then
427                 say >&3 "expecting success: $2"
428                 test_run_ "$2"
429                 if [ "$?" = 0 -a "$eval_ret" = 0 ]
430                 then
431                         test_ok_ "$1"
432                 else
433                         test_failure_ "$@"
434                 fi
435         fi
436         echo >&3 ""
437 }
438
439 test_expect_code () {
440         test "$#" = 4 && { prereq=$1; shift; } || prereq=
441         test "$#" = 3 ||
442         error "bug in the test script: not 3 or 4 parameters to test-expect-code"
443         if ! test_skip "$@"
444         then
445                 say >&3 "expecting exit code $1: $3"
446                 test_run_ "$3"
447                 if [ "$?" = 0 -a "$eval_ret" = "$1" ]
448                 then
449                         test_ok_ "$2"
450                 else
451                         test_failure_ "$@"
452                 fi
453         fi
454         echo >&3 ""
455 }
456
457 # test_external runs external test scripts that provide continuous
458 # test output about their progress, and succeeds/fails on
459 # zero/non-zero exit code.  It outputs the test output on stdout even
460 # in non-verbose mode, and announces the external script with "* run
461 # <n>: ..." before running it.  When providing relative paths, keep in
462 # mind that all scripts run in "trash directory".
463 # Usage: test_external description command arguments...
464 # Example: test_external 'Perl API' perl ../path/to/test.pl
465 test_external () {
466         test "$#" = 4 && { prereq=$1; shift; } || prereq=
467         test "$#" = 3 ||
468         error >&5 "bug in the test script: not 3 or 4 parameters to test_external"
469         descr="$1"
470         shift
471         if ! test_skip "$descr" "$@"
472         then
473                 # Announce the script to reduce confusion about the
474                 # test output that follows.
475                 say_color "" " run $test_count: $descr ($*)"
476                 # Run command; redirect its stderr to &4 as in
477                 # test_run_, but keep its stdout on our stdout even in
478                 # non-verbose mode.
479                 "$@" 2>&4
480                 if [ "$?" = 0 ]
481                 then
482                         test_ok_ "$descr"
483                 else
484                         test_failure_ "$descr" "$@"
485                 fi
486         fi
487 }
488
489 # Like test_external, but in addition tests that the command generated
490 # no output on stderr.
491 test_external_without_stderr () {
492         # The temporary file has no (and must have no) security
493         # implications.
494         tmp="$TMPDIR"; if [ -z "$tmp" ]; then tmp=/tmp; fi
495         stderr="$tmp/git-external-stderr.$$.tmp"
496         test_external "$@" 4> "$stderr"
497         [ -f "$stderr" ] || error "Internal error: $stderr disappeared."
498         descr="no stderr: $1"
499         shift
500         say >&3 "expecting no stderr from previous command"
501         if [ ! -s "$stderr" ]; then
502                 rm "$stderr"
503                 test_ok_ "$descr"
504         else
505                 if [ "$verbose" = t ]; then
506                         output=`echo; echo Stderr is:; cat "$stderr"`
507                 else
508                         output=
509                 fi
510                 # rm first in case test_failure exits.
511                 rm "$stderr"
512                 test_failure_ "$descr" "$@" "$output"
513         fi
514 }
515
516 # This is not among top-level (test_expect_success | test_expect_failure)
517 # but is a prefix that can be used in the test script, like:
518 #
519 #       test_expect_success 'complain and die' '
520 #           do something &&
521 #           do something else &&
522 #           test_must_fail git checkout ../outerspace
523 #       '
524 #
525 # Writing this as "! git checkout ../outerspace" is wrong, because
526 # the failure could be due to a segv.  We want a controlled failure.
527
528 test_must_fail () {
529         "$@"
530         test $? -gt 0 -a $? -le 129 -o $? -gt 192
531 }
532
533 # test_cmp is a helper function to compare actual and expected output.
534 # You can use it like:
535 #
536 #       test_expect_success 'foo works' '
537 #               echo expected >expected &&
538 #               foo >actual &&
539 #               test_cmp expected actual
540 #       '
541 #
542 # This could be written as either "cmp" or "diff -u", but:
543 # - cmp's output is not nearly as easy to read as diff -u
544 # - not all diff versions understand "-u"
545
546 test_cmp() {
547         $GIT_TEST_CMP "$@"
548 }
549
550 # This function can be used to schedule some commands to be run
551 # unconditionally at the end of the test to restore sanity:
552 #
553 #       test_expect_success 'test core.capslock' '
554 #               git config core.capslock true &&
555 #               test_when_finished "git config --unset core.capslock" &&
556 #               hello world
557 #       '
558 #
559 # That would be roughly equivalent to
560 #
561 #       test_expect_success 'test core.capslock' '
562 #               git config core.capslock true &&
563 #               hello world
564 #               git config --unset core.capslock
565 #       '
566 #
567 # except that the greeting and config --unset must both succeed for
568 # the test to pass.
569
570 test_when_finished () {
571         test_cleanup="{ $*
572                 } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
573 }
574
575 # Most tests can use the created repository, but some may need to create more.
576 # Usage: test_create_repo <directory>
577 test_create_repo () {
578         test "$#" = 1 ||
579         error "bug in the test script: not 1 parameter to test-create-repo"
580         owd=`pwd`
581         repo="$1"
582         mkdir -p "$repo"
583         cd "$repo" || error "Cannot setup test environment"
584         "$GIT_EXEC_PATH/git-init" "--template=$TEST_DIRECTORY/../templates/blt/" >&3 2>&4 ||
585         error "cannot run git init -- have you built things yet?"
586         mv .git/hooks .git/hooks-disabled
587         cd "$owd"
588 }
589
590 test_done () {
591         GIT_EXIT_OK=t
592         test_results_dir="$TEST_DIRECTORY/test-results"
593         mkdir -p "$test_results_dir"
594         test_results_path="$test_results_dir/${0%.sh}-$$"
595
596         echo "total $test_count" >> $test_results_path
597         echo "success $test_success" >> $test_results_path
598         echo "fixed $test_fixed" >> $test_results_path
599         echo "broken $test_broken" >> $test_results_path
600         echo "failed $test_failure" >> $test_results_path
601         echo "" >> $test_results_path
602
603         if test "$test_fixed" != 0
604         then
605                 say_color pass "fixed $test_fixed known breakage(s)"
606         fi
607         if test "$test_broken" != 0
608         then
609                 say_color error "still have $test_broken known breakage(s)"
610                 msg="remaining $(($test_count-$test_broken)) test(s)"
611         else
612                 msg="$test_count test(s)"
613         fi
614         case "$test_failure" in
615         0)
616                 say_color pass "passed all $msg"
617
618                 test -d "$remove_trash" &&
619                 cd "$(dirname "$remove_trash")" &&
620                 rm -rf "$(basename "$remove_trash")"
621
622                 exit 0 ;;
623
624         *)
625                 say_color error "failed $test_failure among $msg"
626                 exit 1 ;;
627
628         esac
629 }
630
631 # Test the binaries we have just built.  The tests are kept in
632 # t/ subdirectory and are run in 'trash directory' subdirectory.
633 TEST_DIRECTORY=$(pwd)
634 if test -n "$valgrind"
635 then
636         make_symlink () {
637                 test -h "$2" &&
638                 test "$1" = "$(readlink "$2")" || {
639                         # be super paranoid
640                         if mkdir "$2".lock
641                         then
642                                 rm -f "$2" &&
643                                 ln -s "$1" "$2" &&
644                                 rm -r "$2".lock
645                         else
646                                 while test -d "$2".lock
647                                 do
648                                         say "Waiting for lock on $2."
649                                         sleep 1
650                                 done
651                         fi
652                 }
653         }
654
655         make_valgrind_symlink () {
656                 # handle only executables
657                 test -x "$1" || return
658
659                 base=$(basename "$1")
660                 symlink_target=$TEST_DIRECTORY/../$base
661                 # do not override scripts
662                 if test -x "$symlink_target" &&
663                     test ! -d "$symlink_target" &&
664                     test "#!" != "$(head -c 2 < "$symlink_target")"
665                 then
666                         symlink_target=../valgrind.sh
667                 fi
668                 case "$base" in
669                 *.sh|*.perl)
670                         symlink_target=../unprocessed-script
671                 esac
672                 # create the link, or replace it if it is out of date
673                 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
674         }
675
676         # override all git executables in TEST_DIRECTORY/..
677         GIT_VALGRIND=$TEST_DIRECTORY/valgrind
678         mkdir -p "$GIT_VALGRIND"/bin
679         for file in $TEST_DIRECTORY/../git* $TEST_DIRECTORY/../test-*
680         do
681                 make_valgrind_symlink $file
682         done
683         OLDIFS=$IFS
684         IFS=:
685         for path in $PATH
686         do
687                 ls "$path"/git-* 2> /dev/null |
688                 while read file
689                 do
690                         make_valgrind_symlink "$file"
691                 done
692         done
693         IFS=$OLDIFS
694         PATH=$GIT_VALGRIND/bin:$PATH
695         GIT_EXEC_PATH=$GIT_VALGRIND/bin
696         export GIT_VALGRIND
697 elif test -n "$GIT_TEST_INSTALLED" ; then
698         GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path)  ||
699         error "Cannot run git from $GIT_TEST_INSTALLED."
700         PATH=$GIT_TEST_INSTALLED:$TEST_DIRECTORY/..:$PATH
701         GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
702 else # normal case, use ../bin-wrappers only unless $with_dashes:
703         git_bin_dir="$TEST_DIRECTORY/../bin-wrappers"
704         if ! test -x "$git_bin_dir/git" ; then
705                 if test -z "$with_dashes" ; then
706                         say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
707                 fi
708                 with_dashes=t
709         fi
710         PATH="$git_bin_dir:$PATH"
711         GIT_EXEC_PATH=$TEST_DIRECTORY/..
712         if test -n "$with_dashes" ; then
713                 PATH="$TEST_DIRECTORY/..:$PATH"
714         fi
715 fi
716 GIT_TEMPLATE_DIR=$(pwd)/../templates/blt
717 unset GIT_CONFIG
718 GIT_CONFIG_NOSYSTEM=1
719 GIT_CONFIG_NOGLOBAL=1
720 export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_CONFIG_NOGLOBAL
721
722 . ../GIT-BUILD-OPTIONS
723
724 GITPERLLIB=$(pwd)/../perl/blib/lib:$(pwd)/../perl/blib/arch/auto/Git
725 export GITPERLLIB
726 test -d ../templates/blt || {
727         error "You haven't built things yet, have you?"
728 }
729
730 if test -z "$GIT_TEST_INSTALLED" && test -z "$NO_PYTHON"
731 then
732         GITPYTHONLIB="$(pwd)/../git_remote_helpers/build/lib"
733         export GITPYTHONLIB
734         test -d ../git_remote_helpers/build || {
735                 error "You haven't built git_remote_helpers yet, have you?"
736         }
737 fi
738
739 if ! test -x ../test-chmtime; then
740         echo >&2 'You need to build test-chmtime:'
741         echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
742         exit 1
743 fi
744
745 # Test repository
746 test="trash directory.$(basename "$0" .sh)"
747 test -n "$root" && test="$root/$test"
748 case "$test" in
749 /*) TRASH_DIRECTORY="$test" ;;
750  *) TRASH_DIRECTORY="$TEST_DIRECTORY/$test" ;;
751 esac
752 test ! -z "$debug" || remove_trash=$TRASH_DIRECTORY
753 rm -fr "$test" || {
754         GIT_EXIT_OK=t
755         echo >&5 "FATAL: Cannot prepare test area"
756         exit 1
757 }
758
759 test_create_repo "$test"
760 # Use -P to resolve symlinks in our working directory so that the cwd
761 # in subprocesses like git equals our $PWD (for pathname comparisons).
762 cd -P "$test" || exit 1
763
764 this_test=${0##*/}
765 this_test=${this_test%%-*}
766 for skp in $GIT_SKIP_TESTS
767 do
768         to_skip=
769         for skp in $GIT_SKIP_TESTS
770         do
771                 case "$this_test" in
772                 $skp)
773                         to_skip=t
774                 esac
775         done
776         case "$to_skip" in
777         t)
778                 say_color skip >&3 "skipping test $this_test altogether"
779                 say_color skip "skip all tests in $this_test"
780                 test_done
781         esac
782 done
783
784 # Provide an implementation of the 'yes' utility
785 yes () {
786         if test $# = 0
787         then
788                 y=y
789         else
790                 y="$*"
791         fi
792
793         while echo "$y"
794         do
795                 :
796         done
797 }
798
799 # Fix some commands on Windows
800 case $(uname -s) in
801 *MINGW*)
802         # Windows has its own (incompatible) sort and find
803         sort () {
804                 /usr/bin/sort "$@"
805         }
806         find () {
807                 /usr/bin/find "$@"
808         }
809         sum () {
810                 md5sum "$@"
811         }
812         # git sees Windows-style pwd
813         pwd () {
814                 builtin pwd -W
815         }
816         # no POSIX permissions
817         # backslashes in pathspec are converted to '/'
818         # exec does not inherit the PID
819         ;;
820 *)
821         test_set_prereq POSIXPERM
822         test_set_prereq BSLASHPSPEC
823         test_set_prereq EXECKEEPSPID
824         ;;
825 esac
826
827 test -z "$NO_PERL" && test_set_prereq PERL
828 test -z "$NO_PYTHON" && test_set_prereq PYTHON
829
830 # test whether the filesystem supports symbolic links
831 ln -s x y 2>/dev/null && test -h y 2>/dev/null && test_set_prereq SYMLINKS
832 rm -f y